import { ASUtil } from "@assemblyscript/loader";
export declare function validatArgument(includes: unknown, excludes: unknown): void;
export declare class ImportsArgument {
    module: WebAssembly.Module | null;
    instance: WebAssembly.Instance | null;
    exports: (ASUtil & Record<string, unknown>) | null;
}
export type Imports = ((arg: ImportsArgument) => Record<string, unknown>) | null;
export interface FileOption {
    includes: string[];
    excludes: string[];
    testcases: string[] | undefined;
}
export interface TestOption {
    flags: string;
    imports: Imports;
}
export interface OutputOption {
    tempFolder: string;
    outputFolder: string;
    mode: OutputMode | OutputMode[];
    warnLimit?: number;
    errorLimit?: number;
}
export type OutputMode = "html" | "json" | "table";
/**
 * main function of unit-test, will throw Exception in most condition except job carsh
 */
export declare function start_unit_test(fo: FileOption, to: TestOption, oo: OutputOption): Promise<boolean>;
//# sourceMappingURL=index.d.ts.map